/************************************************************
                                          2009 2/1 
  Linux KeyHoleTV (C) 2008,2009          OISEYER Inc.
                                        Takashi Kosaka

   Japanese String Table (EUC)
   
   File: JString.c

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions
   are met:
   
   - Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
   
   - Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
   
   - Neither the name of the Xiph.org Foundation nor the names of its
   contributors may be used to endorse or promote products derived from
   this software without specific prior written permission.
   
   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR
   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
   EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
************************************************************/
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <iconv.h>
#include <errno.h>

static char *hoi0 =   /* ID_ONLINE_LABEL 0 */   "饤";
static char *hoi1 = /* ID_ONLINE_TIP   1 */     "%s ϡߥ饤Ǥåȥե饤ˤʤޤξ֤ǡȤ򸫤뤳ȤǤޤ";
static char *hoi2 =   /* ID_OFFLINE_LABEL 2 */    "ե饤";
static char *hoi3 = /* ID_OFFLINE_TIP   3 */      "%s ϡߥե饤Ǥ饤ˤˤϥåƤ";
static char *hoi4 =   /* ID_STOPWATCH     4 */      "İ";
static char *hoi5 =   /* ID_STOPWATCH_TIP 5 */      "ȤλİߤޤȤѹ硢ޤİߤƤԤä";
static char *hoi6 = /* ID_CHAT          6 */      "ԤؤΥå";
static char *hoi7 =  /* ID_CHAT_TIP     7 */      "ԤؤΥåȥɥ򳫤ޤ";
static char *hoi8 = /* ID_VIDEO_TIP     8 */      "ӥǥɽޤ֥륯ḁ̊ɥ򳫤ޤ";
static char *hoi9 =   /* ID_VIDEO_TAB     9 */      "ӥǥ";
static char *hoi10 =  /* ID_VIDEO_TABL_TIP 10 */     "Υ֤ϡӥǥɽΥ֤Ǥ";
static char *hoi11 =   /* ID_PROGRAM       11 */     "";
static char *hoi12 = /* ID_PROGRAM_TIP    12 */     "Υ֤ϡ߻İǤȤɽޤ";
static char *hoi13 = /* ID_WATCH          13 */     "Ȥ򸫤";
static char *hoi14 =  /* ID_WATCH_TIP     14 */    "򤵤ƤȤ򸫤뤳ȤǤޤ";
static char *hoi15 =   /* ID_LIST_ITEM_TIP1 15 */     "󥰥륯å%s ξܺ\n֥륯å%s λİ";
static char *hoi16 =   /* ID_LIST_ITME_TIP2 16 */     "֥륯å  %s λİ ";
static char *hoi17 =  /* ID_SEARCH_TIP     17 */     "ӥǥȤ򸡺ʸϤޤ";
static char *hoi18 =  /* ID_SEARCH_BUTTON  18 */     "";
static char *hoi19 =  /* ID_SEARCH_BUTTON_TIP 19 */  "ȸ򳫻Ϥޤ";
static char *hoi20 =  /* ID_VIDEOWIN_TIP   20 */     "ΥɥϡӥǥɽޤѤɥå뤳Ȥǡ礭ѹǤޤܤ礭ܤ˾ʤޤ";
static char *hoi21 =  /* ID_WINDOW_TIP     21 */     "򥯥å뤳ȤǡɥĤޤ";
static char *hoi22 =  /* ID_FONT_SELECT_TIP 22 */    "ѲǽʥեȰ";
static char *hoi23 =  /* ID_FONT_SET        23 */    "ե";
static char *hoi24 =  /* ID_FONT_SET_TIP    24 */    "ꤷեȤǥåɽԤޤ";
static char *hoi25 =  /* ID_INPUT_CHAT      25 */    "åʸϤޤContol-VǥڡǤޤ";
static char *hoi26 =  /* ID_SEND            26 */    "";
static char *hoi27 =  /* ID_SEND_TIP        27 */    "ϤʸԤޤ";
static char *hoi28 =  /* ID_STOP_FEED       28 */    "ԤӥǥߤƤޤ";
static char *hoi29 =  /* ID_CURRENT         29 */    "İԿ:%4d";
static char *hoi30 =  /* ID_MAX             30 */    "İԿ:%4d";
static char *hoi31 =  /* ID_LOCK            31 */    "İԲ";
static char *hoi32 =  /* ID_UNLOCK          32 */    "İġ";
static char *hoi33 =  /* ID_CHAT_WIN_TITLE  33 */    "ԤؤΥåȥɥ";
static char *hoi34 =  /* ID_CHAT_OUT_TIP    34 */    "åɽޤޥ򤷤ʸ¾˥ڡȤǤޤޤɽեȤѹǤޤ";
static char *hoi35 =  /* ID_VIDEO_WIN_TITLE 35 */     "ӥǥɽɥ";
static char *hoi36 =  /* ID_NOW_LOGIN       36 */     "";
static char *hoi37 =  /* ID_LOGIN_FAIL      37 */     "ॢȥ  ͥåȥåƤ";
static char *hoi38 =   /* ID_LOGIN_SUCCESS   38  */    "ޤ";
static char *hoi39 =   /* ID_SUCCESS_WATCH   39 */     "ȼ";
static char *hoi40 =  /* ID_SUCCESS_NOT_WATCH 40 */   "Ȥ֤ȤǤޤ";
static char *hoi41 =   /* ID_SEARCHING        41 */   "ȸ";
static char *hoi42 =  /* ID_SEARCH_DONE       42 */   "ȸλޤ";
static char *hoi43 =  /* ID_SERVER_NOT_RESPOND 43 */  "Фޤ󡣥󤷤ʤƤ";
static char *hoi44 =   /* ID_TIME_FORMAT       44*/   "%s%4dǯ%2d%2d %2d%2dʬ%2dá[̤]\r\n";
static char *hoi45 =  /* ID_TIME_FORMAT_DONE   545 */  "%s%4dǯ%2d%2d %2d%2dʬ%2dá[λ]\r\n";
static char *hoi46 =  /* ID_ERROR_NETWROK_CALL 46 */  "ͥåȥ饤֥˥顼ȯޤλƤ";
static char *hoi47 =  /* ID_LOGIN_KEYHOLE      47 */  "̤ %s Ω夬äƤޤ";
static char *hoi48 =  /* ID_LIST_UPDATE        48 */  "ȥꥹȹ";
static char *hoi49 =  /* ID_LIST_UPDATE_DONE   49 */  "ȥꥹȹλ";
static char *hoi50 =  /* ID_LOGOUT_TRYING      50 */  "Ƚ";
static char *hoi51 =  /* ID_LOGOUT_DONE        51 */  "ȴλ";
static char *hoi52 =  /* ID_TRY_WATCH,         52 */  "Ȥ³";
static char *hoi53 =  /* ID_TRY_NOT_WATCH,     53 */  "Ȥλİλ";
static char *hoi54 =  /* ID_ROOM_NOT_EXIT      54 */  "Ȥλޤ";
static char *hoi55 =  /* ID_MAX_USER           55 */  "İǤͿĶƤޤ";
static char *hoi56 =  /* ID_LOCKED_ROOM        56 */  "߻İǤʤ֤Ǥ";
static char *hoi57 =  /* ID_OWNER_LEAVE        57 */  "ԤȤ潪λޤ";
static char *hoi58 =  /* ID_RECEIVE_CHAT       58 */  "%s%4dǯ%2d%2d %2d%2dʬ%2dá[]\r\n";
static char *hoi59 =  /* ID_END_ASK,           59 */  "%s λޤ";
static char *hoi60 =  /* ID_END_MESSAGE        60 */  "λǧ";
static char *hoi61 =  /* ID_MAIN_WIN_MESSAGE   61 */  "Υܥ򲡤ȡ̿ߤƥץꥱ󤬽λޤ";
static char *hoi62 =  /* ID_TOO_MANY_STRING    62 */  "åʸ¿ޤ";
static char *hoi63 =  /* ID_OPENING_WEB        63 */  "򳫤Ƥޤ";
static char *hoi64 =  /* ID_ADVER_TIP          64 */  "ɽԤޤåоݤΥ֥ڡ򳫤ޤ";
static char *hoi65 =  /* ID_SERVER_ADDR_NOTIFY 65 */ "С󤬥꡼ޤåƥåץǡȤԤäƤ";
static char *hoi66 =  /* ID_CALL_NOTIFY        66 */ "  äθƤӽФǤKeyHoleVideoǤľƤ";
static char *hoi67 =  /* ID_MUTE_ON_BUTTON,    67 */ "ò";
static char *hoi68 =  /* ID_MUTE_OFF_BUTTON    68 */ "ò";
static char *hoi69 =  /* ID_MUTE_ON_TIP        69 */ "ߡϤƤ֤Ǥåȡòˤʤޤ";
static char *hoi70 =  /* ID_MUTE_OFF_TIP       70 */ "ߡò֤Ǥåȡͭˤʤޤ";
static char *hoi71 =  /* ID_MORE_THAN_5        71 */ "顼";
static char *hoi72 =  /* ID_MORE_THAN_5_COM    72 */ "%s ˣİʾΩ夬äƤޤ";
static char *hoi73 =  /* ID_FORMAT_PROGRAM     73 */ "İ %4d";
static char *hoi74 =  /* ID_LIST_PARENT_ITEM_TIP1 74 */ "%såȤꥹȤ򳫤ꡦĤꤷޤ";
static char *hoi75 =  /* ID_UPDATE_MODULE_DONE 75 */    " %s ꡼ޤåץǡȤꤤޤåȥΥڡޤ";
static char *hoi76 =  /* ID_CLOSE_BUTTON      76 */    "Ĥ";
static char *hoi77 =  /* ID_CLOSE_BUTTON_TIP  77 */    "Υܥ򥯥åȡΥɥĤޤ";
static char *hoi78 =  /* ID_UPDATE_WINDOW_TITLE   78 */ "%s С󥢥åץǡ";
static char *hoi79 =  /* ID_OK,                   79 */ "OK";
static char *hoi80 =  /* ID_OK_TIP,               80 */ "ϤѥɤȤİޤ";
static char *hoi81 =  /* ID_CANCEL,               81 */ "ä";
static char *hoi82 =  /* ID_CANCEL_TIP,           82 */ "ѥդȤλİޤ";
static char *hoi83 =  /* ID_INPUT_PASSS_TIP,      83 */ "Ȥİ뤿˥ѥɤϤޤ";
static char *hoi84 =  /* ID_PASSWORD_FAIL,        84 */ "ꤵ줿ѥɤְäƤޤ";
static char *hoi85 =  /* ID_PASSWORD_PRGRAM,      85 */ "ѥդ";
static char *hoi86 =  /* ID_PRGRAM_UPDAET,        86 */ "ȹ";
static char *hoi87 =  /* ID_PRGRAM_UPDAET_TIP     87 */ "åȥꥹȤ򹹿ޤ";
static char *hoi88 =  /* ID_VOL_SLIDER_TIP        88 */ "ܥ塼ѹޤ礭Ͼʤޤ";
static char *hoi89 =  /* ID_VOL_DISPLY_TIP,       89 */ "ܥ塼֤ɽޤ";
static char *hoi90 =  /* ID_NOT_TOPMOST           90 */     "̲";
static char *hoi91 =  /* ID_TOPMOST               91 */     "";
static char *hoi92 =  /* ID_NOT_TOPMOST_TIP       92 */ "%s ϡ˺̤ΥɥǤåȡ̤ޤ";
static char *hoi93 =  /* ID_TOPMOST_TIP           93 */ "%sϡ̾Υɥ֤Ǥåȡ˺̤Υɥˤʤޤ";
static char *hoi94 =  /* ID_ALREAY_LOGIN          94 */ "ФȽǤФ餯Ԥäơ󤷤Ƥ";
static char *hoi95 =  /* ID_ADMIN_FORCE_LOGOUT,   95 */ "ƥԤФ׵ᤷޤ";
static char *hoi96 =  /* ID_ADMIN_FORCE_CHANGE,   96 */ "̤ΥФ³Ԥޤ";
static char *hoi97 =    /* ID_AUDIO_DIEVICE,      97 */ "ǥ/ӥǥ";
static char *hoi98 =    /* ID_UNIX_DSP,           98 */ "UNIX DSP";
static char *hoi99 =    /* ID_ESD,                99 */ "ESD";

static char *hoi100 =    /* ID_ALSA,              100 */ "ALSA";
static char *hoi101 =    /* ID_USE_GTK,           101 */ "ӥǥɽGTK";
static char *hoi102 =    /* ID_UNIX_DSP_TIP,      102 */ "ǥϤ /dev/dsp Ѥޤ";
static char *hoi103 =    /* ID_ESD_TIP,           103 */ "ǥϤ Enligtenment Sound Daemon Ѥޤ";
static char *hoi104 =    /* ID_ALSA_TIP,          104 */ "ǥϤˡAdvanced Linux Sound Architecture Ѥޤ";
static char *hoi105 =    /* ID_USE_GTK_TIP,         105 */ "ӥǥɽGTK(GDK) WidgetѤޤXФ̿ԤΤǡXФ̿ǽ˰¸ޤ";
static char *hoi106 =    /* ID_AUDIO_DEVICE_CANCEL   106 */ "";
static char *hoi107 =    /* ID_AUDIO_DEVICE_APPLY,   107 */ "Ŭ";
static char *hoi108 =    /* ID_AUDIO_DEVICE_CANCEL_TIP 108 */ "򤵤Ƥ륪ǥϤޤ";
static char *hoi109 =    /* ID_AUDIO_DEVICE_APPLY_TIP, 109 */ "򤵤Ƥ륪ǥϤŬޤ";
static char *hoi110 =    /* ID_ALSA_COMBO_TIP,         110 */ "ALSA ѤǥХ̾Ϥޤ";
static char *hoi111 =    /* ID_ADD_BUTTON,             111 */ "ɲ";
static char *hoi112 =    /* ID_ADD_BUTTON_TIP,         112 */ "Ϥ줿ǥХ̾ꥹȤɲäޤ磵ĤޤϿǤޤ";
static char *hoi113 =    /* ID_DELETE_BUTTON           113 */ "";
static char *hoi114 =    /* ID_DELETE_BUTTON_TIP,      114 */ "򤵤줿ǥХ̾ꥹȤޤ";
static char *hoi115 =    /* ID_AUDIO_DEVICE_ERROR,     115 */ " 򤵤줿ǥХϡѤǤޤ";
static char *hoi116 =    /* ID_USE_SDL,                116 */ "ӥǥɽSDL";
static char *hoi117 =    /* ID_USE_SDL_TIP,            117 */ "ӥǥɽSDL (Simple Direct Layer)Ѥ̤Υե졼ХåեɽԤޤ̥ɥɽޤ";
static char *hoi118 =    /* ID_NOT_LOAD_LIBRARY,       118 */ "饤֥꤬ʤܥ뤬褷Ƥޤ";
static char *hoi119 =    /* ID_SDL_SELECTED,           119 */ "SDLͭǤ̥ɥϳޤ";
static char *hoi120 =     /* ID_HELP_TIP    ,          120 */ "KeyHoleTVإץ֥ڡ򳫤ޤ";

static char *hoi121 = /* ID_USER_NAME_LABEL            121 */   "Ѽ̾"; 
static char *hoi122 = /* ID_PASSWORD_LABEL             122 */   "ѥ"; 
static char *hoi123 = /* ID_NEW_PASSWORD_LABEL         123 */   "ѥ"; 
static char *hoi124 = /* ID_RE_NEW_PASSWORD_LABEL      124 */   "ƿѥ"; 
static char *hoi125 = /* ID_USER_NAME_TIP              125 */   "Ѽ̾Ϥޤե饤ˤȡѼ̾ѹǤޤϿϤޤ"; 
static char *hoi126 = /* ID_PASSWORD_TIP               126 */   "ѥɤϤޤѥϸ塢֤ݡʥե饤ɽˤ򲡲ƥ󤹤뤫CRǤǽǤ"; 
static char *hoi127 = /* ID_NEW_PASSWORD_TIP           127 */   "ѥɤϤޤ"; 
static char *hoi128 = /* ID_RENEW_PASSWORD_TIP         128 */   "ѥɤϤޤ"; 
static char *hoi129 = /* ID_REGISTER                   129 */   "ѼϿ"; 
static char *hoi130 = /* ID_REGISTER_TIP               130 */   "ѼԤϿޤĤKeyHoleTVǰĤѼԤϿǤޤ磴̾ޤϿǽǤ¸Ѽ̾ϰ̾Ǥ,㣴ʸʾϤƤ";
static char *hoi131 =  /* ID_CHANGE_PASS               131 */   "ѥɤѹ"; 
static char *hoi132 =  /* ID_CHANGE_PASS_TIP           132 */   "ѥɤѹԤޤߤΥѥɡѥɡѥɤκϤɬפǤ"; 
static char *hoi133 = /* ID_USER_INFO                  133 */   "ѼԾ";
static char *hoi134 = /* ID_USER_INFO_TIP              134 */   "ѼԾɽ륿֤Ǥ";
static char *hoi135 = /* ID_PREMIUM_MODULE_KEY         135 */   "ץߥ⥸塼륭";
static char *hoi136 = /* ID_PREMIUM_FULL_TIP           136 */   "ץߥ⥸塼륭ͭǤ塢%dѲǽǤ";
static char *hoi137 = /* ID_PREMIUM_HALF_TIP           137 */   "ץߥ⥸塼륭ͭ¤ޤʤλޤ%dѲǽǤץߥ⥸塼륭ʤȡŪ˥Ȥİߤޤ";
static char *hoi138 = /* ID_PREMIUM_NON_TIP            138 */   "ͭʥץߥ⥸塼륭ϿƤޤ󡣥ץߥ⥸塼륭ʤȡŪ˥Ȥİߤޤ";
static char *hoi139 = /* ID_PREMIUM_FULL_B_TIP         139 */   "ץߥ⥸塼륭ͭǤΥܥ򲡲ȡץߥ⥸塼륭Ǥ򳫤ޤ֤ͭǤäƤ⡢֤ɲäǽǤ";
static char *hoi140 = /* ID_PREMIUM_HALF_B_TIP         140 */   "ޤʤץߥ⥸塼륭ͭ¤λޤΥܥ򲡲ȡץߥ⥸塼륭Ǥ򳫤ޤ֤ͭǤäƤ⡢֤ɲäǽǤ";
static char *hoi141 = /* ID_PREMIUM_NON_B_TIP          141 */   "ͭץߥ⥸塼륭ϿƤޤ󡣥ץߥ⥸塼륭ʤȡŪ˥ȤİߤޤΥܥ򲡲ȡץߥ⥸塼륭Ǥɽޤ";
static char *hoi142 = /* ID_CURRENT_KEY                142 */   "ꤵƤץߥ⥸塼륭";
static char *hoi143 = /* ID_TOO_MANY                   143 */   "İʾKeyHoleTVΩ夬äƤޤ";
static char *hoi144 = /* ID_LOGOUT_WAIT                144 */   "ƱѼ̾KeyHoleTVѤƤޤ";
static char *hoi145 = /* ID_CHANGE_PASS_OK_TIP         145 */   "ꤷѥɤѹޤ";
static char *hoi146 = /* ID_VOl_SLIDER                 146 */   "ܥ塼ॹ饤";
static char *hoi147 = /* ID_PROGRAM_PASSWORD           147 */   "ȥѥ";
static char *hoi148 = /* ID_PROGRAM_SEARCH_INPUT       148 */   "ȸ";
static char *hoi149 = /* ID_FONT_SELECT_COMBO          149 */   "ե򥳥ܥܥå";
static char *hoi150 = /* ID_CHAT_INPUT                 150 */   "å";
static char *hoi151 = /* ID_CREATE_OK_TIP              151 */   "ϤѼ̾ѥɤϿޤ̾ޤϿǤޤKeyHoleTVǵΤϰ̾Ǥ";
static char *hoi152 = /* ID_CREATE_CANCEL_TIP          152 */   "Ͽäޤ";
static char *hoi153 = /* ID_REGISTER_OK_TIP            153 */   "ϤѼ̾ѥɤϿԤʤޤ̾ޤϿǤޤKeyHoleTVǵΤϰ̾Ǥ";
static char *hoi154 = /* ID_CAHNGE_PASS_CANCEL_TIP     154 */   "ѥѹäޤ";
static char *hoi155 = /* ID_WRONG_PASSWORD             155 */   "Ѽ̾㤦ѥɤְäƤޤ";
static char *hoi156 = /* ID_WRONG_PASSWORD_2           156 */   "Ϥѥɤ㤤ޤ";
static char *hoi157 = /* ID_BUSY_SERVER                157 */   "ФѼϿƤޤФ餯Ͽ򤷤Ƥ";
static char *hoi158 = /* ID_SAME_USER_EXIST            158 */   "˻ȤƤѼ̾Ǥ̤̾ˤƤ";
static char *hoi159 = /* ID_TRING_CREATE               159 */   "ѼϿ...";
static char *hoi160 = /* ID_TRING_CREATE_DONE          160 */   "ѼϿλǽѼԤKeyHoleTVϵޤ";
static char *hoi161 = /* ID_TRING_CREATE_FAIL          161 */   "ѼϿԤޤ";
static char *hoi162 = /* ID_NO_REGISTORE_USER          162 */   "ϤƤϡѼϿ򤷤ƤǤʤϡִ¸Ѽ̾ץܥ򥯥åƤ";
static char *hoi163 = /* ID_PASSWORD_CHANGING          163 */   "ѥѹ...";
static char *hoi164 = /* ID_PASSWORD_CHANGE_DONE1      164 */   "ѥɤѹλ¸ޤ";
static char *hoi165 = /* ID_PASSWORD_CHANGE_DONE2      165 */   "ѥɤѹλޤ¸Ϥޤ";
static char *hoi166 = /* ID_PASSWORD_cHANGE_FAILE      166 */   "ѥɤѹϼԤޤ";
static char *hoi167 = /* ID_REGITOER_OK_LABEL          167 */   "ѼϿ";
static char *hoi168 = /* ID_PASSWORD_OL_LABEL          168 */   "ѥѹ";
static char *hoi169 = /* ID_BUY                        169 */   "ץߥ⥸塼륭";
static char *hoi170 = /* ID_BUY_TIP                    170 */   "ץߥ⥸塼륭뤿Webڡ򳫤ޤץߥ⥸塼륭֤ͭɲäǤޤ";
static char *hoi171 = /* ID_EXISTING_USER              171 */   "¸Ѽ̾";
static char *hoi172 = /* ID_EXISTING_USER_TIP          172 */   "¸Ѽ̾ǥǤڡ˰ܤޤ";
static char *hoi173 = /* ID_EXISTING_LOGIN             173 */   "";
static char *hoi174 = /* ID_EXISTING_LOGIN_TIP         174 */   "ɽƤѼ̾ǥ򤷤ޤ";
static char *hoi175 = /* ID_EXISTING_LOGIN_OP_TIP      175 */   "Ѽ̾ȥѥɤϤơ֥ץܥ򥯥åޤǡ¸Ѽ̾ǥǤϿƤʤ硢Ѽ̾PC¸ޤ";


/**************************************************************
 String 
**************************************************************/
static char *TKTable[176][512];

/**********************************************************
  IConv 
**********************************************************/
static int IConv(iconv_t fd,char *I,int InSize,char *O,int OutSize)
{
  size_t In,Out,KK,TT;
  char *PI,*PO;

  PI = I;
  PO = O;

  if( InSize == 0 ) {
    In  = strlen(I);
  }
  else {
    In  = InSize;
  }
  Out = OutSize;

  KK = iconv(fd,(char **)&PI,&In,(char **)&PO,&Out);
  TT = OutSize - Out;

  if( KK  >= 0 ) {
    *(O + TT) = 0x00;
  }
  else {
    KK = 0;
    /*    
	  fprintf(stderr,"Error ICONV !!! KK:%ld %d %ld %d %d %s %ld %d\n",
	  KK,errno,E2BIG,EILSEQ,EINVAL,O,TT,strlen(O));
    */

    switch( errno ) {
    case  E2BIG:
      fprintf(stderr,"Error ICONV !!! E2BIG\n");
      break;
    case  EILSEQ:
      fprintf(stderr,"Error ICONV !!! EILSEQ:\n");
      break;
    case EINVAL:
      fprintf(stderr,"Error ICONV !!! EINVAL:\n");
      break;
    }
  }
  return((int)TT);
}


/**************************************************************
conv(iconv_t cd,
             char **inbuf, size_t *inbytesleft,
             char **outbuf, size_t *outbytesleft);
***************************************************************/
#define TK_CONVERT(T,O) IConv(Fd,(char *)O,(int)strlen(O),(char *)T,512)

/*************************************************************
  Setup EUC Character to UTF-8
*************************************************************/
void  SetupStrings(char *APP_NAMWE)
{
  iconv_t Fd;
	char    Buf[512];

  /* iconv_open(const char *tocode, const char *fromcode); */
  Fd = iconv_open("UTF-8","EUC-JP");

	TK_CONVERT(TKTable[0] , hoi0);

	sprintf(Buf,hoi1,APP_NAMWE);
  TK_CONVERT(TKTable[1] , Buf);

  TK_CONVERT(TKTable[2] , hoi2);
	sprintf(Buf,hoi3,APP_NAMWE);

  TK_CONVERT(TKTable[3] , Buf);
	TK_CONVERT(TKTable[4] , hoi4);

  TK_CONVERT(TKTable[5] , hoi5);
  TK_CONVERT(TKTable[6] , hoi6);
  TK_CONVERT(TKTable[7] , hoi7);
  TK_CONVERT(TKTable[8] , hoi8);
  TK_CONVERT(TKTable[9] , hoi9);

  TK_CONVERT(TKTable[10] , hoi10);
  TK_CONVERT(TKTable[11] , hoi11);
  TK_CONVERT(TKTable[12] , hoi12);
  TK_CONVERT(TKTable[13] , hoi13);
  TK_CONVERT(TKTable[14] , hoi14);
  TK_CONVERT(TKTable[15] , hoi15);
  TK_CONVERT(TKTable[16] , hoi16);
  TK_CONVERT(TKTable[17] , hoi17);
  TK_CONVERT(TKTable[18] , hoi18);
  TK_CONVERT(TKTable[19] , hoi19);

  TK_CONVERT(TKTable[20] , hoi20);
  TK_CONVERT(TKTable[21] , hoi21);
  TK_CONVERT(TKTable[22] , hoi22);
  TK_CONVERT(TKTable[23] , hoi23);
  TK_CONVERT(TKTable[24] , hoi24);
  TK_CONVERT(TKTable[25] , hoi25);
  TK_CONVERT(TKTable[26] , hoi26);
  TK_CONVERT(TKTable[27] , hoi27);
  TK_CONVERT(TKTable[28] , hoi28);
  TK_CONVERT(TKTable[29] , hoi29);

  TK_CONVERT(TKTable[30] , hoi30);
  TK_CONVERT(TKTable[31] , hoi31);
  TK_CONVERT(TKTable[32] , hoi32);
  TK_CONVERT(TKTable[33] , hoi33);
  TK_CONVERT(TKTable[34] , hoi34);
  TK_CONVERT(TKTable[35] , hoi35);
  TK_CONVERT(TKTable[36] , hoi36);
  TK_CONVERT(TKTable[37] , hoi37);
  TK_CONVERT(TKTable[38] , hoi38);
  TK_CONVERT(TKTable[39] , hoi39);

  TK_CONVERT(TKTable[40] , hoi40);
  TK_CONVERT(TKTable[41] , hoi41);
  TK_CONVERT(TKTable[42] , hoi42);
  TK_CONVERT(TKTable[43] , hoi43);
  TK_CONVERT(TKTable[44] , hoi44);
  TK_CONVERT(TKTable[45] , hoi45);
  TK_CONVERT(TKTable[46] , hoi46);
	sprintf(Buf,hoi47,APP_NAMWE);
  TK_CONVERT(TKTable[47] , Buf);

  TK_CONVERT(TKTable[48] , hoi48);
  TK_CONVERT(TKTable[49] , hoi49);

  TK_CONVERT(TKTable[50] , hoi50);
  TK_CONVERT(TKTable[51] , hoi51);
  TK_CONVERT(TKTable[52] , hoi52);
  TK_CONVERT(TKTable[53] , hoi53);
  TK_CONVERT(TKTable[54] , hoi54);
  TK_CONVERT(TKTable[55] , hoi55);
  TK_CONVERT(TKTable[56] , hoi56);
  TK_CONVERT(TKTable[57] , hoi57);
  TK_CONVERT(TKTable[58] , hoi58);
  
  sprintf(Buf,hoi59,APP_NAMWE);
  TK_CONVERT(TKTable[59] , Buf);

  TK_CONVERT(TKTable[60] , hoi60);
  TK_CONVERT(TKTable[61] , hoi61);
  TK_CONVERT(TKTable[62] , hoi62);
  TK_CONVERT(TKTable[63] , hoi63);
  TK_CONVERT(TKTable[64] , hoi64);
  TK_CONVERT(TKTable[65] , hoi65);
  TK_CONVERT(TKTable[66] , hoi66);
  TK_CONVERT(TKTable[67] , hoi67);
  TK_CONVERT(TKTable[68] , hoi68);
  TK_CONVERT(TKTable[69] , hoi69);

  TK_CONVERT(TKTable[70] , hoi70);
  TK_CONVERT(TKTable[71] , hoi71);

  sprintf(Buf,hoi72,APP_NAMWE);
  TK_CONVERT(TKTable[72] , Buf);

  TK_CONVERT(TKTable[73] , hoi73);
  TK_CONVERT(TKTable[74] , hoi74);

	sprintf(Buf,hoi75,APP_NAMWE);
  TK_CONVERT(TKTable[75] , Buf);
  TK_CONVERT(TKTable[76] , hoi76);
  TK_CONVERT(TKTable[77] , hoi77);

	sprintf(Buf,hoi78,APP_NAMWE);
  TK_CONVERT(TKTable[78] , Buf);
  TK_CONVERT(TKTable[79] , hoi79);

  TK_CONVERT(TKTable[80] , hoi80);
  TK_CONVERT(TKTable[81] , hoi81);
  TK_CONVERT(TKTable[82] , hoi82);
  TK_CONVERT(TKTable[83] , hoi83);
  TK_CONVERT(TKTable[84] , hoi84);
  TK_CONVERT(TKTable[85] , hoi85);
  TK_CONVERT(TKTable[86] , hoi86);
  TK_CONVERT(TKTable[87] , hoi87);
  TK_CONVERT(TKTable[88] , hoi88);
  TK_CONVERT(TKTable[89] , hoi89);

  TK_CONVERT(TKTable[90] , hoi90);
  TK_CONVERT(TKTable[91] , hoi91);
	sprintf(Buf,hoi92,APP_NAMWE);
  TK_CONVERT(TKTable[92] , Buf);

  sprintf(Buf,hoi93,APP_NAMWE);
  TK_CONVERT(TKTable[93] , Buf);
  TK_CONVERT(TKTable[94] , hoi94);
  TK_CONVERT(TKTable[95] , hoi95);
  TK_CONVERT(TKTable[96] , hoi96);
  TK_CONVERT(TKTable[97] , hoi97);
  TK_CONVERT(TKTable[98] , hoi98);
  TK_CONVERT(TKTable[99] , hoi99);

  TK_CONVERT(TKTable[100] , hoi100);
  TK_CONVERT(TKTable[101] , hoi101);
  TK_CONVERT(TKTable[102] , hoi102);
  TK_CONVERT(TKTable[103] , hoi103);
  TK_CONVERT(TKTable[104] , hoi104);
  TK_CONVERT(TKTable[105] , hoi105);
  TK_CONVERT(TKTable[106] , hoi106);
  TK_CONVERT(TKTable[107] , hoi107);
  TK_CONVERT(TKTable[108] , hoi108);
  TK_CONVERT(TKTable[109] , hoi109);

  TK_CONVERT(TKTable[110] , hoi110);
  TK_CONVERT(TKTable[111] , hoi111);
  TK_CONVERT(TKTable[112] , hoi112);
  TK_CONVERT(TKTable[113] , hoi113);
  TK_CONVERT(TKTable[114] , hoi114);
  TK_CONVERT(TKTable[115] , hoi115);
  TK_CONVERT(TKTable[116] , hoi116);
  TK_CONVERT(TKTable[117] , hoi117);
  TK_CONVERT(TKTable[118] , hoi118);
  TK_CONVERT(TKTable[119] , hoi119);
  TK_CONVERT(TKTable[120] , hoi120);

  TK_CONVERT(TKTable[121] , hoi121);
  TK_CONVERT(TKTable[122] , hoi122);
  TK_CONVERT(TKTable[123] , hoi123);
  TK_CONVERT(TKTable[124] , hoi124);
  TK_CONVERT(TKTable[125] , hoi125);
  TK_CONVERT(TKTable[126] , hoi126);
  TK_CONVERT(TKTable[127] , hoi127);
  TK_CONVERT(TKTable[128] , hoi128);
  TK_CONVERT(TKTable[129] , hoi129);
  TK_CONVERT(TKTable[130] , hoi130);

  TK_CONVERT(TKTable[131] , hoi131);
  TK_CONVERT(TKTable[132] , hoi132);
  TK_CONVERT(TKTable[133] , hoi133);
  TK_CONVERT(TKTable[134] , hoi134);
  TK_CONVERT(TKTable[135] , hoi135);
  TK_CONVERT(TKTable[136] , hoi136);
  TK_CONVERT(TKTable[137] , hoi137);
  TK_CONVERT(TKTable[138] , hoi138);
  TK_CONVERT(TKTable[139] , hoi139);
  TK_CONVERT(TKTable[140] , hoi140);

  TK_CONVERT(TKTable[141] , hoi141);
  TK_CONVERT(TKTable[142] , hoi142);
  TK_CONVERT(TKTable[143] , hoi143);
  TK_CONVERT(TKTable[144] , hoi144);
  TK_CONVERT(TKTable[145] , hoi145);
  TK_CONVERT(TKTable[146] , hoi146);
  TK_CONVERT(TKTable[147] , hoi147);
  TK_CONVERT(TKTable[148] , hoi148);
  TK_CONVERT(TKTable[149] , hoi149);
  TK_CONVERT(TKTable[150] , hoi150);

  TK_CONVERT(TKTable[151] , hoi151);
  TK_CONVERT(TKTable[152] , hoi152);
  TK_CONVERT(TKTable[153] , hoi153);
  TK_CONVERT(TKTable[154] , hoi154);
  TK_CONVERT(TKTable[155] , hoi155);
  TK_CONVERT(TKTable[156] , hoi156);
  TK_CONVERT(TKTable[157] , hoi157);
  TK_CONVERT(TKTable[158] , hoi158);
  TK_CONVERT(TKTable[159] , hoi159);
  TK_CONVERT(TKTable[160] , hoi160);

  TK_CONVERT(TKTable[161] , hoi161);
  TK_CONVERT(TKTable[162] , hoi162);
  TK_CONVERT(TKTable[163] , hoi163);
  TK_CONVERT(TKTable[164] , hoi164);
  TK_CONVERT(TKTable[165] , hoi165);
  TK_CONVERT(TKTable[166] , hoi166);
  TK_CONVERT(TKTable[167] , hoi167);
  TK_CONVERT(TKTable[168] , hoi168);
  TK_CONVERT(TKTable[169] , hoi169);
  TK_CONVERT(TKTable[170] , hoi170);

  TK_CONVERT(TKTable[171] , hoi171);
  TK_CONVERT(TKTable[172] , hoi172);
  TK_CONVERT(TKTable[173] , hoi173);
  TK_CONVERT(TKTable[174] , hoi174);
  TK_CONVERT(TKTable[175] , hoi175);

  iconv_close(Fd);
}

char *GetStringFromStringTable(int ID)
{
  return((char *)TKTable[ID]);
}

